#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

void print_siginfo(siginfo_t *info)
{
  printf("siginfo dump: ");
  printf("si_signo: %d, ", info->si_signo);
  printf("si_errno: %d, ", info->si_errno);
  printf("si_code: %d, si_value.sival_int: %d\n", info->si_code,
	 info->si_value.sival_int);
}

void usr1_action(int signo, siginfo_t *info, void *context)
{
  print_siginfo(info);
}

int main(void)
{
  struct sigaction act;
  union sigval val;
  int i;

  act.sa_flags = SA_SIGINFO;
  act.sa_sigaction = usr1_action;
  sigemptyset(&act.sa_mask);

  if (sigaction(SIGUSR1, &act, NULL)) {
    perror("sigaction failed");
    exit(1);
  }
  
  kill(getpid(), SIGUSR1);

  for (i = 0; i < 10; i++) {
    val.sival_int = i;
    sigqueue(getpid(), SIGUSR1, val);
  }

  return 0;
}
